import matplotlib.pyplot as plt

year = [1880, 1900, 1920, 1940, 1960, 1980, 2000]
pop  = [959_596, 2_014_100, 3_699_428, 7_354_971,
        9_683_802, 11_618_281, 12_064_101]

#       日本語表記の設定
plt.rcParams['font.family'] = ['Yu Gothic', 'Noto Sans CJK JP',
                                   'Hiragino Maru Gothic Pro']

plt.plot(year, pop)
pop_v = [2_500_000 * i for i in range(1, 6)]
pop_L = ['{}'.format(v) for v in pop_v]
plt.yticks(pop_v, pop_L)
plt.ylabel('人\n口', fontsize = 14, rotation = 0)
plt.xlabel('年次', fontsize = 14)
plt.title('東京都人口推移', fontsize = 16)
plt.tight_layout()
plt.show()
