import matplotlib.pyplot as plt
import numpy as np

data = [
        (70, 168), (68, 165), (62, 159), (56, 156), (70, 170),
        (64, 162), (59, 162), (70, 169), (68, 168), (69, 170),
        (67, 168), (63, 166), (58, 163), (74, 170), (65, 168),
        (60, 160), (65, 165), (72, 175), (61, 164), (77, 174),
        (68, 164), (64, 161), (70, 166), (47, 147), (66, 165),
        (68, 170), (73, 174), (74, 172), (63, 164), (83, 182),
        (58, 159), (64, 166), (67, 167), (75, 174), (67, 163),
        (68, 166), (68, 167), (66, 165), (63, 165), (55, 154),
        (61, 163), (60, 160), (62, 164), (62, 160), (59, 160),
        (51, 155), (59, 163), (68, 170), (56, 157), (79, 180)]

weight = []
height = []
for w, h in data:
    weight.append(w)
    height.append(h)

print(weight)
print(height)

#       日本語表記の設定
plt.rcParams['font.family'] = ['Yu Gothic', 'Noto Sans CJK JP',
                                   'Hiragino Maru Gothic Pro']

bins_v1 = np.arange(45, 86, 5)
results = plt.hist(weight, bins = bins_v1)
plt.xlabel('体重', fontsize = 14)
plt.ylabel('度\n数', fontsize = 14, rotation = 0)
plt.title('体重のヒストグラム', fontsize = 16)
plt.tight_layout()
plt.show()
print('\n体重：')
print('最小値 =', min(weight), '  最大値 =', max(weight))
print('境界値：', results[1])
print('度数：', results[0])

bins_v2 = np.arange(145, 186, 5)
results = plt.hist(height, bins = bins_v2)
plt.xlabel('身長', fontsize = 14)
plt.ylabel('度\n数', fontsize = 14, rotation = 0)
plt.title('身長のヒストグラム', fontsize = 16)
plt.tight_layout()
plt.show()
print('\n身長：')
print('最小値 =', min(height), '  最大値 =', max(height))
print('境界値：', results[1])
print('度数：', results[0])

plt.scatter(weight, height, marker = 'o')
plt.xlabel('体重', fontsize = 14)
plt.ylabel('身\n長', fontsize = 14, rotation = 0)
plt.title('散布図', fontsize = 16)
plt.tight_layout()
plt.show()
