import matplotlib.pyplot as plt
import numpy as np

data = [
        (70, 168), (68, 165), (62, 159), (56, 156), (70, 170),
        (64, 162), (59, 162), (70, 169), (68, 168), (69, 170),
        (67, 168), (63, 166), (58, 163), (74, 170), (65, 168),
        (60, 160), (65, 165), (72, 175), (61, 164), (77, 174),
        (68, 164), (64, 161), (70, 166), (47, 147), (66, 165),
        (68, 170), (73, 174), (74, 172), (63, 164), (83, 182),
        (58, 159), (64, 166), (67, 167), (75, 174), (67, 163),
        (68, 166), (68, 167), (66, 165), (63, 165), (55, 154),
        (61, 163), (60, 160), (62, 164), (62, 160), (59, 160),
        (51, 155), (59, 163), (68, 170), (56, 157), (79, 180)]

data = np.array(data)
print(data)

N = len(data)
print('N =', N)

a = (N * np.sum(data.T[0] * data.T[1]) -
     np.sum(data.T[0]) * np.sum(data.T[1])) / \
     (N * np.sum(data.T[0]**2) - np.sum(data.T[0])**2)
b = (np.sum(data.T[0]**2) * np.sum(data.T[1]) -
      np.sum(data.T[0]) * np.sum(data.T[0] * data.T[1])) / \
     (N * np.sum(data.T[0]**2) - np.sum(data.T[0])**2)

print('a =', a)
print('b =', b)

#       日本語表記の設定
plt.rcParams['font.family'] = ['Yu Gothic', 'Noto Sans CJK JP',
                                   'Hiragino Maru Gothic Pro']

plt.plot(data.T[0], data.T[1], 'o')
x_min = np.min(data.T[0])
x_max = np.max(data.T[0])
plt.plot([x_min, x_max], [a*x_min + b, a*x_max + b],
         label = 'a = {0:.3f}\nb = {1:.3f}'.format(a, b))
plt.title('回帰式　a*x + b', fontsize = 24)
plt.legend(fontsize = 12)
plt.show()
