import csv
import numpy as np


fin_name = input('Data file name(*.csv) = ')
with open(fin_name, 'r') as f:
    data = [v for v in csv.reader(f)]
 
fout_name = input('Output file name(*.txt) = ')
fout = open(fout_name, 'w')
fout.write('Data file name = {}\n'.format(fin_name))

print('Data file...')
fout.write('\nData...\n')
for v in data:
    for w in v:
        print('{0: >7s}'.format(w), end = '')
        fout.write('{0: >7s}'.format(w))
    print()
    fout.write('\n')


ck_cnt = data[0][1:]
cnts = np.bincount(ck_cnt)
print(cnts)
a = len(cnts) - 1
ck_cnt = data[1][1:]
cnts = np.bincount(ck_cnt)
b = len(cnts) - 1
N = len(data) - 2
print('a = ', a)
print('b = ', b)
print('N = ', N)

Y = np.zeros((N, a, b))
for i in range(N):
    for j in range(a):
        for k in range(b):
            Y[i][j][k] = float(data[i+2][1 + k + j*b])

for i in range(N):
    for j in range(a):
        for k in range(b):
            print('{0:>7.1f}'.format(Y[i][j][k]), end = '')
    print()

Yppp = Y.mean()
print('Y... = ', Yppp)
fout.write('\nY... = {}\n'.format(Yppp))
Ypjk = np.zeros((a, b))
for j in range(a):
    for k in range(b):
        Ypjk[j][k] = Y[:,j,k].mean()

print('\nY.jk =')
fout.write('\nY.jk =\n')
for j in range(a):
    for k in range(b):
        print('{0:>10.2f}'.format(Ypjk[j][k]), end = '')
        fout.write('{0:>10.2f}'.format(Ypjk[j][k]))

print()
fout.write('\n')

Ypjp = np.zeros(a)
for j in range(a):
    Ypjp[j] = Y[:,j,:].mean()
print('Y.j. = ')
fout.write('\nY.j. =\n')
for j in range(a):
    print('{0:>10.2f}'.format(Ypjp[j]), end = '')
    fout.write('{0:>10.2f}'.format(Ypjp[j]))
print()
fout.write('\n')

Yppk = np.zeros(b)
for k in range(b):
    Yppk[k] = Y[:,:,k].mean()
print('Y..k =')
fout.write('\nY..k =\n')
for k in range(b):
    print('{0:>10.2f}'.format(Yppk[k]), end = '')
    fout.write('{0:>10.2f}'.format(Yppk[k]))
print()
fout.write('\n')
               


SS_A = b * N * np.sum((Ypjp - Yppp)**2)

SS_B = a * N * np.sum((Yppk - Yppp)**2)

SS_AB = 0.0
for j in range(a):
    for k in range(b):
        SS_AB += (Ypjk[j][k] - Ypjp[j] - Yppk[k] + Yppp)**2
SS_AB *= N

SS_T = np.sum((Y - Yppp)**2)
SS_S_AB = SS_T - SS_A - SS_B - SS_AB

dfT = a * b * N
dfA = a - 1
dfB = b - 1
dfAB = (a - 1) * (b - 1)
dfS_AB = a * b * (N-1)

MS_A = SS_A / dfA
MS_B = SS_B / dfB
MS_AB = SS_AB / dfAB
MS_S_AB = SS_S_AB / dfS_AB

F_A = MS_A / MS_S_AB
F_B = MS_B / MS_S_AB
F_AB = MS_AB / MS_S_AB

import scipy.stats as ss

p_a = 1.0 - ss.f.cdf(F_A, dfA, dfS_AB)
p_b = 1.0 - ss.f.cdf(F_B, dfB, dfS_AB)
p_ab = 1.0 - ss.f.cdf(F_AB, dfAB, dfS_AB)

print('\n')
print('{0: >10s}{1: >10s}{2: >10s}{3: >10s}{4: >10s}{5: >10s}'.
      format(' ', 'SS', 'df', 'MS', 'F', 'P(>F)'))
fout.write('\n{0: >10s}{1: >10s}{2: >10s}{3: >10s}{4: >10s}{5: >10s}\n'.
      format(' ', 'SS', 'df', 'MS', 'F', 'P(>F)'))
print('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}{4: >10.2f}{5: >10.5f}'.
      format('A', SS_A, dfA, MS_A, F_A, p_a))
fout.write('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}{4: >10.2f}{5: >10.5f}\n'.
      format('A', SS_A, dfA, MS_A, F_A, p_a))
print('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}{4: >10.2f}{5: >10.5f}'.
      format('B', SS_B, dfB, MS_B, F_B, p_b))
fout.write('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}{4: >10.2f}{5: >10.5f}\n'.
      format('B', SS_B, dfB, MS_B, F_B, p_b))
print('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}{4: >10.2f}{5: >10.5f}'.
      format('AB', SS_AB, dfAB, MS_AB, F_AB, p_ab))
fout.write('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}{4: >10.2f}{5: >10.5f}\n'.
      format('AB', SS_AB, dfAB, MS_AB, F_AB, p_ab))
print('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}'.
      format('S/AB', SS_S_AB, dfS_AB, MS_S_AB))
fout.write('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}\n'.
      format('S/AB', SS_S_AB, dfS_AB, MS_S_AB))


fout.close()
print('\nOutput file {} was saved.\n'.format(fout_name))
